<!DOCTYPE html>
<html>

<head>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.7.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <style>
        .ancestors * {
            display: block;
            border: 2px solid lightgrey;
            color: lightgrey;
            padding: 5px;
            margin: 15px;
        }

        .descendants * {
            display: block;
            border: 2px solid lightgrey;
            color: lightgrey;
            padding: 5px;
            margin: 15px;
        }
    </style>
    <script>
        "use strict";
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
        $(document).ready(function () {
            $("#btn-set-color-children").on("click", setColorForChildren);
            $("#btn-set-color-children-class-a").on("click", setColorForChildAClass);
            $("#btn-set-color-children-class-b").on("click", setColorForChildBClass)
            $("#btn-search-parents").on("click", setColorForParents);
            $("#btn-filter-setting").on("click", setFilterSetting);
        });
        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */

        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        // button 1: set color for children
        // TODO: ấn thử nút để xem kết quả
        function setColorForChildren() {
            console.log("find the children");
            $(".descendants")   // select những element có class descendants
                .children()       //chọn children của các element này
                .css({ "color": "red", "border": "2px solid red" }); //set màu, border... 
        }
        // button 2: set color for child-a class
        // TODO: ấn thử nút để xem kết quả
        function setColorForChildAClass() {
            $(".descendants")  //select những element có class descendants
                .children()  //select elemetns
                .find(".child-a")  //tìm những element có class child-a
                .css({ "color": "blue", "border": "2px solid red" });
        }

        // button 3: set color for child-b class
        // TODO: thực hiện code cho nút (3) để set color cho child-b theo cách khác đã làm ở button 2
        function setColorForChildBClass() {
            $(".descendants")  //select những element có class descendants
                .children()  //select elemetns
                .eq(1)
                .children()
                .eq(0)
                .css({ "color": "blue", "border": "2px solid red" });
        }

        // button 4: set color for parents
        function setColorForParents() {
            console.log("parents");
            $("#span-d").css({ "color": "blue", "border": "2px solid blue" });
            // TODO: hãy bỏ comment (mỗi lần CHỈ THỬ 1 dòng) để thử lần lượt các dòng lệnh này 
            //$("#span-d").parent().css({"color": "blue", "border": "2px dotted green"}); // cha trực tiếp
            //$("#span-d").parents("ul").css({"color": "blue", "border": "2px dotted green"});
            //$("#span-d").parents().last().css({ "color": "blue", "border": "2px dotted green" }); //document body
            //$("div").last().find("li").css("border", "1px solid blue");
            //$("div.form-group").find("div").last().find("li").css("border", "1px solid blue");
        }

        // button 5: div filter setting
        // TODO: tìm thẻ p đầu tiên là con của thẻ div class .descendants theo 2 cách
        function setFilterSetting() {
            $(".descendants")
                .children()
                //.first()    // Cách 1
                .eq(0)
                .css("border", "1px solid blue");
        }
    </script>
</head>

<body>
    <div class="container">
        <div class="form-group">
            <h1> select children - select element con - cháu - ... </h1>
            <div class="descendants" style="width:500px;">div (current element)
                <p>p (child 1 )
                    <span class="child-a">span (grandchild A)</span>
                </p>
                <p>p (child 2)
                    <span class="child-b">span (grandchild B)</span>
                </p>
            </div>
            <button class="btn btn-info" id="btn-set-color-children"> (1) set color for children </button>
            <button class="btn btn-success" id="btn-set-color-children-class-a"> (2) set color for grand child A
            </button>
            <button class="btn btn-danger" id="btn-set-color-children-class-b"> (3) set color for grand child B
            </button>


            <h1> select ancestors - select parent - grandparent - ... </h1>
            <div style="width:500px;">div (great-grandparent)
                <ul>ul (grandparent) b
                    <li>li (direct parent)
                        <span id="span-d">span D</span>
                    </li>
                </ul>

            </div>
            <button class="btn btn-info" id="btn-search-parents"> (4) parents setting </button>
            <button class="btn btn-success" id="btn-filter-setting"> (5) div filter setting </button>
        </div>
    </div>
</body>

</html>